import{s as Le,n as Pe,o as Ne}from"../chunks/scheduler.182ea377.js";import{S as ze,i as He,g as o,s as l,p as H,A as Se,h as n,f as t,c as i,j as u,q as S,m as p,k as a,v as s,a as d,r as I,d as F,t as U,u as B}from"../chunks/index.008d68e4.js";import{D as ve}from"../chunks/Docstring.7aec8b85.js";import{I as _e}from"../chunks/IconCopyLink.96bbb92b.js";function Ie(ge){let m,W,f,g,K,k,ie,A,be="VQModel",J,Q,we='The VQ-VAE model was introduced in <a href="https://huggingface.co/papers/1711.00937" rel="nofollow">Neural Discrete Representation Learning</a> by Aaron van den Oord, Oriol Vinyals and Koray Kavukcuoglu. The model is used in 🤗 Diffusers to decode latent representations into images. Unlike <a href="/docs/diffusers/v0.25.0/en/api/models/autoencoderkl#diffusers.AutoencoderKL">AutoencoderKL</a>, the <a href="/docs/diffusers/v0.25.0/en/api/models/vq#diffusers.VQModel">VQModel</a> works in a quantized latent space.',G,x,Ve="The abstract from the paper is:",X,$,ye="<em>Learning useful representations without supervision remains a key challenge in machine learning. In this paper, we propose a simple yet powerful generative model that learns such discrete representations. Our model, the Vector Quantised-Variational AutoEncoder (VQ-VAE), differs from VAEs in two key ways: the encoder network outputs discrete, rather than continuous, codes; and the prior is learnt rather than static. In order to learn a discrete latent representation, we incorporate ideas from vector quantisation (VQ). Using the VQ method allows the model to circumvent issues of “posterior collapse” — where the latents are ignored when they are paired with a powerful autoregressive decoder — typically observed in the VAE framework. Pairing these representations with an autoregressive prior, the model can generate high quality images, videos, and speech as well as doing high quality speaker conversion and unsupervised learning of phonemes, providing further evidence of the utility of the learnt representations.</em>",Y,h,b,R,q,de,D,ke="VQModel",Z,c,M,ce,O,Qe="A VQ-VAE model for decoding latent representations.",ue,L,xe=`This model inherits from <a href="/docs/diffusers/v0.25.0/en/api/models/overview#diffusers.ModelMixin">ModelMixin</a>. Check the superclass documentation for it’s generic methods implemented
for all models (such as downloading or saving).`,pe,w,E,me,P,$e='The <a href="/docs/diffusers/v0.25.0/en/api/models/vq#diffusers.VQModel">VQModel</a> forward method.',ee,v,V,j,T,fe,N,qe="VQEncoderOutput",te,_,C,he,z,Me="Output of VQModel encoding method.",oe;return k=new _e({}),q=new _e({}),M=new ve({props:{name:"class diffusers.VQModel",anchor:"diffusers.VQModel",parameters:[{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"down_block_types",val:": Tuple = ('DownEncoderBlock2D',)"},{name:"up_block_types",val:": Tuple = ('UpDecoderBlock2D',)"},{name:"block_out_channels",val:": Tuple = (64,)"},{name:"layers_per_block",val:": int = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"latent_channels",val:": int = 3"},{name:"sample_size",val:": int = 32"},{name:"num_vq_embeddings",val:": int = 256"},{name:"norm_num_groups",val:": int = 32"},{name:"vq_embed_dim",val:": Optional = None"},{name:"scaling_factor",val:": float = 0.18215"},{name:"norm_type",val:": str = 'group'"},{name:"mid_block_add_attention",val:" = True"},{name:"lookup_from_codebook",val:" = False"},{name:"force_upcast",val:" = False"}],parametersDescription:[{anchor:"diffusers.VQModel.in_channels",description:"<strong>in_channels</strong> (int, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the input image.",name:"in_channels"},{anchor:"diffusers.VQModel.out_channels",description:"<strong>out_channels</strong> (int,  <em>optional</em>, defaults to 3) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.VQModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;DownEncoderBlock2D&quot;,)</code>) &#x2014;
Tuple of downsample block types.`,name:"down_block_types"},{anchor:"diffusers.VQModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;UpDecoderBlock2D&quot;,)</code>) &#x2014;
Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.VQModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(64,)</code>) &#x2014;
Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.VQModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014; Number of layers per block.",name:"layers_per_block"},{anchor:"diffusers.VQModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.VQModel.latent_channels",description:"<strong>latent_channels</strong> (<code>int</code>, <em>optional</em>, defaults to <code>3</code>) &#x2014; Number of channels in the latent space.",name:"latent_channels"},{anchor:"diffusers.VQModel.sample_size",description:"<strong>sample_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>32</code>) &#x2014; Sample input size.",name:"sample_size"},{anchor:"diffusers.VQModel.num_vq_embeddings",description:"<strong>num_vq_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to <code>256</code>) &#x2014; Number of codebook vectors in the VQ-VAE.",name:"num_vq_embeddings"},{anchor:"diffusers.VQModel.norm_num_groups",description:"<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to <code>32</code>) &#x2014; Number of groups for normalization layers.",name:"norm_num_groups"},{anchor:"diffusers.VQModel.vq_embed_dim",description:"<strong>vq_embed_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; Hidden dim of codebook vectors in the VQ-VAE.",name:"vq_embed_dim"},{anchor:"diffusers.VQModel.scaling_factor",description:`<strong>scaling_factor</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.18215</code>) &#x2014;
The component-wise standard deviation of the trained latent space computed using the first batch of the
training set. This is used to scale the latent space to have unit variance when training the diffusion
model. The latents are scaled with the formula <code>z = z * scaling_factor</code> before being passed to the
diffusion model. When decoding, the latents are scaled back to the original scale with the formula: <code>z = 1 / scaling_factor * z</code>. For more details, refer to sections 4.3.2 and D.1 of the <a href="https://arxiv.org/abs/2112.10752" rel="nofollow">High-Resolution Image
Synthesis with Latent Diffusion Models</a> paper.`,name:"scaling_factor"},{anchor:"diffusers.VQModel.norm_type",description:`<strong>norm_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;group&quot;</code>) &#x2014;
Type of normalization layer to use. Can be one of <code>&quot;group&quot;</code> or <code>&quot;spatial&quot;</code>.`,name:"norm_type"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/vq_model.py#L40"}}),E=new ve({props:{name:"forward",anchor:"diffusers.VQModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.VQModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; Input sample.",name:"sample"},{anchor:"diffusers.VQModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/v0.25.0/en/api/models/vq#diffusers.models.vq_model.VQEncoderOutput">models.vq_model.VQEncoderOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/vq_model.py#L158",returnDescription:`
<p>If return_dict is True, a <a
  href="/docs/diffusers/v0.25.0/en/api/models/vq#diffusers.models.vq_model.VQEncoderOutput"
>VQEncoderOutput</a> is returned, otherwise a plain <code>tuple</code>
is returned.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/v0.25.0/en/api/models/vq#diffusers.models.vq_model.VQEncoderOutput"
>VQEncoderOutput</a> or <code>tuple</code></p>
`}}),T=new _e({}),C=new ve({props:{name:"class diffusers.models.vq_model.VQEncoderOutput",anchor:"diffusers.models.vq_model.VQEncoderOutput",parameters:[{name:"latents",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.vq_model.VQEncoderOutput.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
The encoded output sample from the last layer of the model.`,name:"latents"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/vq_model.py#L27"}}),{c(){m=o("meta"),W=l(),f=o("h1"),g=o("a"),K=o("span"),H(k.$$.fragment),ie=l(),A=o("span"),A.textContent=be,J=l(),Q=o("p"),Q.innerHTML=we,G=l(),x=o("p"),x.textContent=Ve,X=l(),$=o("p"),$.innerHTML=ye,Y=l(),h=o("h2"),b=o("a"),R=o("span"),H(q.$$.fragment),de=l(),D=o("span"),D.textContent=ke,Z=l(),c=o("div"),H(M.$$.fragment),ce=l(),O=o("p"),O.textContent=Qe,ue=l(),L=o("p"),L.innerHTML=xe,pe=l(),w=o("div"),H(E.$$.fragment),me=l(),P=o("p"),P.innerHTML=$e,ee=l(),v=o("h2"),V=o("a"),j=o("span"),H(T.$$.fragment),fe=l(),N=o("span"),N.textContent=qe,te=l(),_=o("div"),H(C.$$.fragment),he=l(),z=o("p"),z.textContent=Me,this.h()},l(e){const r=Se("svelte-1phssyn",document.head);m=n(r,"META",{name:!0,content:!0}),r.forEach(t),W=i(e),f=n(e,"H1",{class:!0});var ne=u(f);g=n(ne,"A",{id:!0,class:!0,href:!0});var Ee=u(g);K=n(Ee,"SPAN",{});var Te=u(K);S(k.$$.fragment,Te),Te.forEach(t),Ee.forEach(t),ie=i(ne),A=n(ne,"SPAN",{"data-svelte-h":!0}),p(A)!=="svelte-1n901kp"&&(A.textContent=be),ne.forEach(t),J=i(e),Q=n(e,"P",{"data-svelte-h":!0}),p(Q)!=="svelte-10o2lmn"&&(Q.innerHTML=we),G=i(e),x=n(e,"P",{"data-svelte-h":!0}),p(x)!=="svelte-1cwsb16"&&(x.textContent=Ve),X=i(e),$=n(e,"P",{"data-svelte-h":!0}),p($)!=="svelte-331jgs"&&($.innerHTML=ye),Y=i(e),h=n(e,"H2",{class:!0});var se=u(h);b=n(se,"A",{id:!0,class:!0,href:!0});var Ce=u(b);R=n(Ce,"SPAN",{});var Ae=u(R);S(q.$$.fragment,Ae),Ae.forEach(t),Ce.forEach(t),de=i(se),D=n(se,"SPAN",{"data-svelte-h":!0}),p(D)!=="svelte-1n901kp"&&(D.textContent=ke),se.forEach(t),Z=i(e),c=n(e,"DIV",{class:!0});var y=u(c);S(M.$$.fragment,y),ce=i(y),O=n(y,"P",{"data-svelte-h":!0}),p(O)!=="svelte-1fe1n0y"&&(O.textContent=Qe),ue=i(y),L=n(y,"P",{"data-svelte-h":!0}),p(L)!=="svelte-zhna7y"&&(L.innerHTML=xe),pe=i(y),w=n(y,"DIV",{class:!0});var re=u(w);S(E.$$.fragment,re),me=i(re),P=n(re,"P",{"data-svelte-h":!0}),p(P)!=="svelte-1y4swta"&&(P.innerHTML=$e),re.forEach(t),y.forEach(t),ee=i(e),v=n(e,"H2",{class:!0});var ae=u(v);V=n(ae,"A",{id:!0,class:!0,href:!0});var De=u(V);j=n(De,"SPAN",{});var Oe=u(j);S(T.$$.fragment,Oe),Oe.forEach(t),De.forEach(t),fe=i(ae),N=n(ae,"SPAN",{"data-svelte-h":!0}),p(N)!=="svelte-i4at41"&&(N.textContent=qe),ae.forEach(t),te=i(e),_=n(e,"DIV",{class:!0});var le=u(_);S(C.$$.fragment,le),he=i(le),z=n(le,"P",{"data-svelte-h":!0}),p(z)!=="svelte-1u2gsdw"&&(z.textContent=Me),le.forEach(t),this.h()},h(){a(m,"name","hf:doc:metadata"),a(m,"content",JSON.stringify(Fe)),a(g,"id","vqmodel"),a(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(g,"href","#vqmodel"),a(f,"class","relative group"),a(b,"id","diffusers.VQModel"),a(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(b,"href","#diffusers.VQModel"),a(h,"class","relative group"),a(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(V,"id","diffusers.models.vq_model.VQEncoderOutput"),a(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(V,"href","#diffusers.models.vq_model.VQEncoderOutput"),a(v,"class","relative group"),a(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){s(document.head,m),d(e,W,r),d(e,f,r),s(f,g),s(g,K),I(k,K,null),s(f,ie),s(f,A),d(e,J,r),d(e,Q,r),d(e,G,r),d(e,x,r),d(e,X,r),d(e,$,r),d(e,Y,r),d(e,h,r),s(h,b),s(b,R),I(q,R,null),s(h,de),s(h,D),d(e,Z,r),d(e,c,r),I(M,c,null),s(c,ce),s(c,O),s(c,ue),s(c,L),s(c,pe),s(c,w),I(E,w,null),s(w,me),s(w,P),d(e,ee,r),d(e,v,r),s(v,V),s(V,j),I(T,j,null),s(v,fe),s(v,N),d(e,te,r),d(e,_,r),I(C,_,null),s(_,he),s(_,z),oe=!0},p:Pe,i(e){oe||(F(k.$$.fragment,e),F(q.$$.fragment,e),F(M.$$.fragment,e),F(E.$$.fragment,e),F(T.$$.fragment,e),F(C.$$.fragment,e),oe=!0)},o(e){U(k.$$.fragment,e),U(q.$$.fragment,e),U(M.$$.fragment,e),U(E.$$.fragment,e),U(T.$$.fragment,e),U(C.$$.fragment,e),oe=!1},d(e){e&&(t(W),t(f),t(J),t(Q),t(G),t(x),t(X),t($),t(Y),t(h),t(Z),t(c),t(ee),t(v),t(te),t(_)),t(m),B(k),B(q),B(M),B(E),B(T),B(C)}}}const Fe={local:"vqmodel",sections:[{local:"diffusers.VQModel",title:"VQModel"},{local:"diffusers.models.vq_model.VQEncoderOutput",title:"VQEncoderOutput"}],title:"VQModel"};function Ue(ge){return Ne(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class We extends ze{constructor(m){super(),He(this,m,Ue,Ie,Le,{})}}export{We as component};
